/* ----------------------------------------------------------------------------
Various Audio Utilities, most quick and/or dirty.
----------------------------------------------------------------------------- */

/*void Decoder::Interleave(short* l, short* r, short* i, long iSize)
{
	for (int j = 0; j < iSize; j++)
	{	i[j*2  ] = l[j];
		i[j*2+1] = r[j];
	}
}


void Decoder::InterleaveG4(short* l, short* r, short* i, long iSize)
{
	vector signed short *ptrL = (vector signed short*) l;
	vector signed short *ptrR = (vector signed short*) r;
	vector signed short *ptrI = (vector signed short*) i;
	
	for (int j = 0; j < iSize/16; j++)
	{	ptrI[j*2  ] = vec_mergeh(ptrL[j], ptrR[j]);
		ptrI[j*2+1] = vec_mergel(ptrL[j], ptrR[j]);
	}
}


void Decoder::Uninterleave(short* i, short* l, short* r, long iSize)
{
	for (int j = 0; j < iSize/2; j++)
	{	l[j] = i[2*j];
		r[j] = i[2*j+1];
	}
}


void Decoder::UninterleaveG4(short* i, short* l, short* r, long iSize)
{
	vector signed short* lv = (vector signed short*) l;
	vector signed short* rv = (vector signed short*) r;
	vector signed short* iv = (vector signed short*) i;
	long loop = iSize/16;

	for (int j = 0; j < loop; j++)
	{	rv[j] = vec_perm(iv[2*j], iv[2*j+1], (vector unsigned char)
								 (0x04, 0x05, 0x06, 0x07,
								  0x0C, 0x0D, 0x0E, 0x0F,
								  0x14, 0x15, 0x16, 0x17,
								  0x1C, 0x1D, 0x1E, 0x1F));
		lv[j] = vec_perm(iv[2*j], iv[2*j+1], (vector unsigned char)
								 (0x00, 0x01, 0x02, 0x03,
								  0x08, 0x09, 0x0A, 0x0B,
								  0x10, 0x11, 0x12, 0x13,
								  0x18, 0x19, 0x1A, 0x1B));
	}
	for (int j = loop*8; j < iSize/2; j++)
	{	l[j] = i[2*j];
		r[j] = i[2*j+1];
	}
}*/


// Reverse Endian-ness: Be careful, this fucks with memory!
inline void Decoder::ReverseShort(unsigned char *buffer, long size)
{
	unsigned long i, j;
	
	// Reverse bytes
	for (i = 0, j = 1; j < size; i+=2, j+=2)
	{
		buffer[i] ^= buffer[j];
		buffer[j] ^= buffer[i];
		buffer[i] ^= buffer[j];
	}
}
