/* ----------------------------------------------------------------------------
AppleScript handling code.  Woo.

Much of this code was taken from MacMPEG2Decoder, since AppleEvents make my
poor head explode (it's happened six times now).
----------------------------------------------------------------------------- */

#include	"AERegistry.h"				// Constants defined in the Registry.

typedef long kRefConType;


// Constants
// ---------
#define cApp			'NULL'
#define pSampleRate		'Rate'
#define pFileType		'FilT'
#define pGainAdjust		'Gain'
#define pSplitChannels	'Splt'
#define pAutoDecode		'AutD'
#define pDestination	'Dest'
#define pAutoFix		'AutF'
#define pUseAltivec		'Altv'
#define pFile			'FiLe'
#define pStart			'Strt'
#define pStop			'Stop'


// Prototypes
// ----------
void InstallAppleEvents(void);

pascal OSErr HandleAEOpenDoc(const AppleEvent*, AppleEvent*, kRefConType);
pascal OSErr HandleAEOpen(const AppleEvent*, AppleEvent*, kRefConType);
pascal OSErr HandleAEQuitNow(const AppleEvent*, AppleEvent*, kRefConType);
pascal OSErr HandleAEPrint(const AppleEvent*, AppleEvent*, kRefConType);
pascal OSErr HandleAEReOpen(const AppleEvent*, AppleEvent*, kRefConType);
pascal OSErr HandleAEPreferences(const AppleEvent*, AppleEvent*, kRefConType);

pascal OSErr AEHandleDecodeStart(const AppleEvent*, AppleEvent *, kRefConType);
pascal OSErr AEHandleDecodeStop(const AppleEvent*, AppleEvent *, kRefConType);

/*pascal OSErr SetAEDataHandler(const AppleEvent*, AppleEvent *, unsigned long);
pascal OSErr GetAEDataHandler(const AppleEvent*, AppleEvent *, unsigned long);
OSErr SetAC3Data(AEDesc*, AEDesc*);
OSErr GetAC3Data(AEDesc*, AEDesc*);*/